/*
 -------------------------------------------------------------------------------
 | Producer - Copyright (C) 2001-2007  Don Burns                               |
 |                                                                             |
 | This library is free software; you can redistribute it and/or modify        |
 | it under the terms of the GNU Lesser General Public License as published    |
 | by the Free Software Foundation; either version 3 of the License, or        |
 | (at your option) any later version.                                         |
 |                                                                             |
 | This library is distributed in the hope that it will be useful, but         |
 | WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  |
 | or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public     |
 | License for more details.                                                   |
 |                                                                             |
 | You should have received a copy of the GNU Lesser General Public License    |
 | along with this software; if not, write to the Free Software Foundation,    |
 | Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.               |
 |                                                                             |
 -------------------------------------------------------------------------------
 */


#ifndef PRODUCER_UTILS_DEF
#define PRODUCER_UTILS_DEF 1

#include <string>

#include <Producer/Types.h>

namespace Producer {
    void (*getProcAddress(const std::string &libraryName, const char *procName))(void);
    void (*getProcAddress(const GLubyte *procName))(void);
    void (*getOpenGLProcAddress(const GLubyte *procName))(void);

    std::string getLibraryName( const std::string & );
    std::string findLibrary( const std::string & );
};

#endif
