/*
 -------------------------------------------------------------------------------
 | Producer - Copyright (C) 2001-2007  Don Burns                               |
 |                                                                             |
 | This library is free software; you can redistribute it and/or modify        |
 | it under the terms of the GNU Lesser General Public License as published    |
 | by the Free Software Foundation; either version 3 of the License, or        |
 | (at your option) any later version.                                         |
 |                                                                             |
 | This library is distributed in the hope that it will be useful, but         |
 | WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  |
 | or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public     |
 | License for more details.                                                   |
 |                                                                             |
 | You should have received a copy of the GNU Lesser General Public License    |
 | along with this software; if not, write to the Free Software Foundation,    |
 | Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.               |
 |                                                                             |
 -------------------------------------------------------------------------------
 */

#ifndef FLKT_RENDER_SURFACE_DEF
#define FLKT_RENDER_SURFACE_DEF 1

#include <Producer/RenderSurface.h>
#include <FL/Fl_Gl_Window.H>

class FLTKRenderSurface: public Producer::RenderSurface, public Fl_Gl_Window
{
    public:

        FLTKRenderSurface( int X, int Y, int W, int H, const char *L="" ):
            Fl_Gl_Window(X, Y, W, H, L)
        {
        }

        virtual bool realize( Producer::VisualChooser *vc=NULL, Producer::GLContext sharedGLContext=0 ) 
        {
            if( _realized ) return _realized;
            _realized = true;
            return _realized;
        }

        void getWindowRectangle( int &_x, int &_y, unsigned int &_width, unsigned int &_height ) const
        {
            _x = x();
            _y = y();
            _width = w();
            _height = h();
        }

        virtual bool makeCurrent( bool ) 
        {
            make_current();
            return true;
        }

        virtual void swapBuffers()
        {
            swap_buffers();
        }

        virtual void draw()
        {
            if( _drawCallback != NULL )
                (*_drawCallback)(this, _drawCallbackData );
        }

        virtual void setDrawCallback( Fl_Callback *callback, void *data )
        {
            _drawCallback = callback;
            _drawCallbackData = data;
        }

    private:
            Fl_Callback *_drawCallback;
            void *_drawCallbackData;
};

#endif

