/*
 -------------------------------------------------------------------------------
 | Producer - Copyright (C) 2001-2007  Don Burns                               |
 |                                                                             |
 | This library is free software; you can redistribute it and/or modify        |
 | it under the terms of the GNU Lesser General Public License as published    |
 | by the Free Software Foundation; either version 3 of the License, or        |
 | (at your option) any later version.                                         |
 |                                                                             |
 | This library is distributed in the hope that it will be useful, but         |
 | WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  |
 | or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public     |
 | License for more details.                                                   |
 |                                                                             |
 | You should have received a copy of the GNU Lesser General Public License    |
 | along with this software; if not, write to the Free Software Foundation,    |
 | Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.               |
 |                                                                             |
 -------------------------------------------------------------------------------
 */


#include <stdlib.h>
#include <string>
#include <Producer/Version.h>

using namespace Producer;

// fallback for windows where the project file doesn't provide the version string
#ifndef PRODUCER_VERSION
#define PRODUCER_VERSION "1.1"
#endif

Version::Version()
{
    std::string str(PRODUCER_VERSION);
    size_t b = 0, e;

    e = str.find(".", b);
    _major = atoi(str.substr(b,b+e).c_str()); 
    b = e+1;
    e = str.find(".", b);
    _minor = atoi(str.substr(b,b+e).c_str()); 
    b = e+1;
    _release = atoi(str.substr(b,str.length()-b).c_str()); 
}

